<div class="row justify-content-center">
    <div class="col-md-6">
        <form name="editForm" role="form" novalidate (ngSubmit)="save()" [formGroup]="editForm">
            <h2 id="myUserLabel" class="header text-center pb-4"  jhiTranslate="cronjobManagement.home.createLabel">
                Create or edit a User
            </h2>

            <div *ngIf="cronjob">
                <div class="form-group">
                    <label class="form-control-label" jhiTranslate="cronjobManagement.name">name</label>
                    <div>
                        <ng-select formControlName="name"
                                   [items]="cronjobList"
                                   bindLabel="name"
                                   [selectableGroup]="true"
                                   [closeOnSelect]="true"
                                   [addTag]="true"
                                   [selectableGroupAsModel]="false"
                                   (change)="selectRecipientList($event)"
                                   (search)="loadCronjobByName($event.term)"
                                   placeholder="{{'cronjobManagement.namePlaceholder' | translate}}"
                                   bindValue="name">
                            <ng-template ng-option-tmp let-item="item" let-item$="item$" let-index="index">
                                {{item.name}}
                            </ng-template>
                        </ng-select>
                    </div>
                    <div *ngIf="editForm.get('name')!.invalid && (editForm.get('name')!.dirty || editForm.get('name')!.touched)">
                        <small class="form-text text-danger"
                               *ngIf="editForm.get('name')?.errors?.maxlength"
                               jhiTranslate="entity.validation.maxlength"
                               [translateValues]="{ max: 255 }">
                            This field cannot be longer than 255 characters.
                        </small>
                        <small class="form-text text-danger"
                               *ngIf="editForm.get('name')?.errors?.required"
                               jhiTranslate="entity.validation.required">
                            This field is required.
                        </small>
                        <small class="form-text text-danger"
                               *ngIf="!editForm.get('name')?.errors?.required && editForm.get('name')?.errors?.noWhitespace"
                               jhiTranslate="error.noWhiteSpace">
                            The value must not be all spaces.
                        </small>
                    </div>
                </div>
                <div class="form-group">
                    <label class="form-control-label" jhiTranslate="cronjobManagement.recipientList">recipientList</label>
                    <div>
                        <ng-select formControlName="recipientList"
                            [items]="recipientLists"
                            bindLabel="name"
                            [selectableGroup]="true"
                            [closeOnSelect]="true"
                            [selectableGroupAsModel]="false"
                            (change)="selectRecipientList($event)"
                            (search)="loadRecipientListByName($event.term)"
                            placeholder="{{'cronjobManagement.recipientListPlaceholder' | translate}}"
                            bindValue="id">
                            <ng-template ng-option-tmp let-item="item" let-item$="item$" let-index="index">
                                <span class="pr-3">{{item.id}}</span> {{item.name}}
                                <a class="float-right text-primary font-weight-light" (click)="viewDetail($event, item)" jhiTranslate="entity.action.view">View detail</a>
                            </ng-template>
                        </ng-select>
                    </div>
                    <div *ngIf="editForm.get('recipientList')!.invalid && (editForm.get('recipientList')!.dirty || editForm.get('recipientList')!.touched)">
                        <small class="form-text text-danger"
                               *ngIf="editForm.get('recipientList')?.errors?.required"
                               jhiTranslate="entity.validation.required">
                            This field is required.
                        </small>
                    </div>
                </div>
                <div class="form-group">
                    <label class="form-control-label" jhiTranslate="cronjobManagement.template"></label>
                    <div>
                        <ng-select formControlName="template"
                                   [items]="mainTemplates"
                                   bindLabel="name"
                                   [selectableGroup]="true"
                                   [closeOnSelect]="true"
                                   (search)="loadTemplateByTypeAndName('MAIN', $event.term)"
                                   [selectableGroupAsModel]="false"
                                   placeholder="{{'cronjobManagement.templatePlaceholder' | translate}}"
                                   bindValue="id">
                            <ng-template ng-option-tmp let-item="item" let-item$="item$" let-index="index">
                                {{item.name}}
                                <a class="float-right text-primary font-weight-light" (click)="viewDetailTemplate($event, item.id)" jhiTranslate="entity.action.view">View detail</a>
                            </ng-template>
                        </ng-select>
                    </div>
                    <div *ngIf="editForm.get('template')!.invalid && (editForm.get('template')!.dirty || editForm.get('template')!.touched)">
                        <small class="form-text text-danger"
                               *ngIf="editForm.get('template')?.errors?.required"
                               jhiTranslate="entity.validation.required">
                            This field is required.
                        </small>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6 form-group">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.templateReminder1"></label>
                        <div>
                            <ng-select formControlName="templateReminder1"
                                       [items]="reminderTemplates1"
                                       bindLabel="name"
                                       [selectableGroup]="true"
                                       [closeOnSelect]="true"
                                       [selectableGroupAsModel]="false"
                                       (search)="loadTemplateByTypeAndName('REMINDER_1', $event.term)"
                                       placeholder="{{'cronjobManagement.templateReminder1Placeholder' | translate}}"
                                       bindValue="id">
                                <ng-template ng-option-tmp let-item="item" let-item$="item$" let-index="index">
                                    {{item.name}}
                                    <a class="float-right text-primary font-weight-light" (click)="viewDetailTemplate($event, item.id)" jhiTranslate="entity.action.view">View detail</a>
                                </ng-template>
                            </ng-select>
                        </div>
                        <div *ngIf="editForm.get('templateReminder1')!.invalid && (editForm.get('templateReminder1')!.dirty || editForm.get('templateReminder1')!.touched)">
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('templateReminder1')?.errors?.required"
                                   jhiTranslate="entity.validation.required">
                                This field is required.
                            </small>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.templateReminderTime1">recipientList</label>
                        <div>
                            <input type="number" formControlName="templateReminderTime1" class="form-control" placeholder="{{'cronjobManagement.templateReminderTimePlaceholder' | translate}}">
                        </div>
                        <div *ngIf="editForm.get('templateReminderTime1')!.invalid && (editForm.get('templateReminderTime1')!.dirty || editForm.get('templateReminderTime1')!.touched)">
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('templateReminderTime1')?.errors?.required"
                                   jhiTranslate="entity.validation.required">
                                This field is required.
                            </small>
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('templateReminderTime1')?.errors?.min"
                                   jhiTranslate="entity.validation.min" [translateValues]="{ min: 1 }">
                            </small>
                        </div>
                        <div *ngIf="editForm.get('templateReminderTime1')!.dirty">
                            <small class="form-text text-danger" jhiTranslate="cronjobManagement.reminderTime1Invalid"
                                   *ngIf="editForm.get('templateReminderTime1')!.value >= editForm.get('templateReminderTime2')!.value">
                                This field must be less than template reminder time 2
                            </small>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6 form-group">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.templateReminder2"></label>
                        <div>
                            <ng-select formControlName="templateReminder2"
                                       [items]="reminderTemplates2"
                                       bindLabel="name"
                                       [selectableGroup]="true"weekDay
                                       [closeOnSelect]="true"
                                       [selectableGroupAsModel]="false"
                                       (search)="loadTemplateByTypeAndName('REMINDER_2', $event.term)"
                                       placeholder="{{'cronjobManagement.templateReminder2Placeholder' | translate}}"
                                       bindValue="id">
                                <ng-template ng-option-tmp let-item="item" let-item$="item$" let-index="index">
                                    {{item.name}}
                                    <a class="float-right text-primary font-weight-light" (click)="viewDetailTemplate($event, item.id)" jhiTranslate="entity.action.view">View detail</a>
                                </ng-template>
                            </ng-select>
                        </div>
                        <div *ngIf="editForm.get('templateReminder2')!.invalid && (editForm.get('templateReminder2')!.dirty || editForm.get('templateReminder2')!.touched)">
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('templateReminder2')?.errors?.required"
                                   jhiTranslate="entity.validation.required">
                                This field is required.
                            </small>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.templateReminderTime2">recipientList</label>
                        <div>
                            <input type="number" formControlName="templateReminderTime2" class="form-control" placeholder="{{'cronjobManagement.templateReminderTimePlaceholder' | translate}}">
                        </div>
                        <div *ngIf="editForm.get('templateReminderTime2')!.invalid && (editForm.get('templateReminderTime2')!.dirty || editForm.get('templateReminderTime2')!.touched)">
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('templateReminderTime2')?.errors?.required"
                                   jhiTranslate="entity.validation.required">
                                This field is required.
                            </small>
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('templateReminderTime2')?.errors?.min"
                                   jhiTranslate="entity.validation.min" [translateValues]="{ min: 1 }">
                            </small>
                        </div>
                        <div *ngIf="editForm.get('templateReminderTime2')!.dirty">
                            <small class="form-text text-danger" jhiTranslate="cronjobManagement.reminderTime2Invalid"
                                   *ngIf="editForm.get('templateReminderTime1')!.value >= editForm.get('templateReminderTime2')!.value">
                                This field must be greater than template reminder time 1
                            </small>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.startDate">startDate</label>
                        <div class="form-group">
                            <div class="input-group">
                                <input [disabled]="!this.editForm.get('recipientList')?.value" (dateSelect)="selectStartDate()" class="form-control" placeholder="{{'cronjobManagement.endDatePlaceholder' | translate}}" formControlName="startDate"
                                       [minDate]="minDate" name="start" ngbDatepicker #start="ngbDatepicker">
                                <div class="input-group-append">
                                    <button (click)="start.toggle()" class="btn btn-outline-secondary" type="button"><fa-icon [icon]="faCalendarAlt"></fa-icon></button>
                                </div>
                            </div>
                            <div *ngIf="editForm.get('startDate')!.invalid && (editForm.get('startDate')!.dirty || editForm.get('startDate')!.touched)">
                                <small class="form-text text-danger"
                                       *ngIf="editForm.get('startDate')?.errors?.required"
                                       jhiTranslate="entity.validation.required">
                                    This field is required.
                                </small>
                            </div>
                            <div>
                                <small class="form-text text-danger" *ngIf="startDate && startDate.isAfter(editForm.get('startDate')?.value, 'day')">
                                    <span jhiTranslate="cronjobManagement.invalidStartDate"> Start date must be </span> {{ startDate | date: 'yyyy-MM-dd' }}
                                </small>
                                <small class="form-text text-danger" *ngIf="invalidStartDate">
                                    <span jhiTranslate="cronjobManagement.invalidWeekOfMonthStartDate"> Week of start date must be </span> {{ getCurrentWeekOfMonth() }}
                                </small>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.endDate">recipientList</label>
                        <i ngbTooltip="{{ 'cronjobManagement.endDateToolTip' | translate}}" class="bi bi-info-circle-fill"></i>
                        <div class="form-group">
                            <div class="input-group">
                                <input [disabled]="!this.editForm.get('recipientList')?.value" (dateSelect)="calculateChunkNumber()" class="form-control" placeholder="{{'cronjobManagement.endDatePlaceholder' | translate}}" formControlName="endDate"
                                     [minDate]="minDate" name="from" ngbDatepicker #from="ngbDatepicker">
                                <div class="input-group-append">
                                    <button (click)="from.toggle()" class="btn btn-outline-secondary" type="button"><fa-icon [icon]="faCalendarAlt"></fa-icon></button>
                                </div>
                            </div>
                            <div *ngIf="editForm.get('endDate')!.invalid && (editForm.get('endDate')!.dirty || editForm.get('endDate')!.touched)">
                                <small class="form-text text-danger"
                                       *ngIf="editForm.get('endDate')?.errors?.required"
                                       jhiTranslate="entity.validation.required">
                                    This field is required.
                                </small>
                            </div>
                            <div *ngIf="editForm.get('endDate')!.touched">
                                <small class="form-text text-warning-custom" *ngIf="endDate.isBefore(editForm.get('endDate')?.value, 'day')">
                                    <span jhiTranslate="cronjobManagement.warningMessage"> End date in fact will end on </span> {{ endDate | date: 'yyyy-MM-dd' }}
                                </small>
                                <small class="form-text text-danger" *ngIf="endDate.isAfter(editForm.get('endDate')?.value, 'day')">
                                    <span jhiTranslate="cronjobManagement.invalidEndDate"> Minimum deadline ends on </span> {{ endDate | date: 'yyyy-MM-dd' }}
                                </small>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row mt-2">
                    <div class="col-md-4 form-group">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.chunkNumber"></label><span ngbTooltip="{{ 'cronjobManagement.totalOfRecipients' | translate}}"> ({{this.totalRecipients}})</span>
                        <div>
                            <input [readOnly]="!this.editForm.get('recipientList')?.value" (ngModelChange)="calculateEndDateAfterChangeChunkNumber()" class="form-control" type="number" formControlName="chunkNumber" placeholder="{{'cronjobManagement.chunkNumberPlaceholder' | translate}}">
                        </div>
                        <div *ngIf="editForm.get('chunkNumber')!.invalid && (editForm.get('chunkNumber')!.dirty || editForm.get('chunkNumber')!.touched)">
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('chunkNumber')?.errors?.required"
                                   jhiTranslate="entity.validation.required">
                                This field is required.
                            </small>
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('chunkNumber')?.errors?.min"
                                   jhiTranslate="entity.validation.min" [translateValues]="{ min: 1 }">
                            </small>
                        </div>
                        <div>
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('chunkNumber')?.value > totalRecipients"
                                   jhiTranslate="cronjobManagement.chunkNumberInvalid">
                                This field is invalid.
                            </small>
                        </div>
                    </div>
                    <div class="col-md-4 form-group">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.date"></label>
                        <div>
                            <ng-select formControlName="weekday"
                                       [items]="dates"
                                       bindLabel="content"
                                       [selectableGroup]="true"
                                       [closeOnSelect]="true"
                                       [selectableGroupAsModel]="false"
                                       (change)="calculateEndDate()"
                                       [readonly]="!this.editForm.get('recipientList')?.value"
                                       placeholder="{{'cronjobManagement.datePlaceholder' | translate}}"
                                       bindValue="value">
                            </ng-select>
                        </div>
                        <div *ngIf="editForm.get('weekday')!.invalid && (editForm.get('weekday')!.dirty || editForm.get('weekday')!.touched)">
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('weekday')?.errors?.required"
                                   jhiTranslate="entity.validation.required">
                                This field is required.
                            </small>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <label class="form-control-label" jhiTranslate="cronjobManagement.time"></label>
                        <div>
                            <ng-select formControlName="sendHour"
                                       [items]="times"
                                       bindLabel="content"
                                       [selectableGroup]="true"
                                       [closeOnSelect]="true"
                                       (change)="calculateEndDate()"
                                       [selectableGroupAsModel]="false"
                                       [readonly]="!this.editForm.get('recipientList')?.value"
                                       placeholder="{{'cronjobManagement.timePlaceholder' | translate}}"
                                       bindValue="value">
                            </ng-select>
                        </div>
                        <div *ngIf="editForm.get('sendHour')!.invalid && (editForm.get('sendHour')!.dirty || editForm.get('sendHour')!.touched)">
                            <small class="form-text text-danger"
                                   *ngIf="editForm.get('sendHour')?.errors?.required"
                                   jhiTranslate="entity.validation.required">
                                This field is required.
                            </small>
                        </div>
                    </div>
                </div>
                <div>
                    <label jhiTranslate="cronjobManagement.frequency"></label>
                    <div class="row align-items-center">
                        <div class="col-md-6" >
                            <div class="row">
                                <label class="col-md-6 mb-0 label-custom">
                                    <input type="radio" value="ONCE_PER_WEEK" formControlName="frequency" (change)="calculateEndDate()">
                                    <span jhiTranslate="cronjobManagement.oncePerWeek"></span>
                                </label>
                                <label class="col-md-6 mb-0 label-custom">
                                    <input type="radio" value="ONCE_PER_TWO_WEEK" formControlName="frequency" (change)="calculateEndDate()">
                                    <span jhiTranslate="cronjobManagement.oncePerTwoWeek"></span>
                                </label>
                            </div>
                        </div>
                        <div class="col-md-6 d-flex align-items-center">
                            <label class="mr-2 mb-0 once-per-month label-custom">
                                <input type="radio" value="ONCE_PER_MONTH" formControlName="frequency" (change)="calculateEndDate()">
                                <span jhiTranslate="cronjobManagement.oncePerMonth"></span>
                            </label>
                            <ng-select class="w-100"
                                       formControlName="weekOfMonth"
                                       [readonly]="selectSchedule()"
                                       placeholder="{{'cronjobManagement.selectWeek' | translate}}"
                                       [items]="weekNumbers"
                                       bindLabel="content"
                                       [selectableGroup]="true"
                                       [clearable]="false"
                                       (change)="calculateEndDate()"
                                       [closeOnSelect]="true"
                                       [selectableGroupAsModel]="false"
                                       bindValue="value">
                            </ng-select>
                        </div>
                    </div>
                    <div *ngIf="editForm.get('frequency')!.invalid && (editForm.get('frequency')!.dirty || editForm.get('frequency')!.touched)">
                        <small class="form-text text-danger"
                               *ngIf="editForm.get('frequency')?.errors?.required"
                               jhiTranslate="entity.validation.required">
                            This field is required.endDate
                        </small>
                    </div>
                </div>
            </div>
            <div *ngIf="cronjob" class="mt-5">
                <button type="button" class="btn btn-outline-primary" (click)="previousState()">
                    <span jhiTranslate="entity.action.back">Cancel</span>
                </button>

                <button type="submit" [disabled]="editForm.invalid || editForm.get('chunkNumber')?.value > totalRecipients
                || editForm.get('templateReminderTime1')!.value >= editForm.get('templateReminderTime2')!.value
                || isSaving
                || (endDate && endDate.diff(editForm.get('endDate')?.value, 'day') > 0)
                || (startDate && startDate.isAfter(editForm.get('startDate')?.value, 'day'))
                || invalidStartDate"
                 class="btn btn-primary float-right">
                    <span jhiTranslate="entity.action.save">Save</span>
                </button>
            </div>
        </form>
    </div>
</div>
